stages:
  - compile
  - test
  - coverage
  - javadoc
  - deploy

image: gradle:7.4.1-jdk17

compile:
  stage: compile
  script:
    - gradle classes

test:
  stage: test
  before_script:
    - cat $APPLICATION_TEST_PROPERTIES_CI > src/main/resources/application-test.properties
  script:
    - gradle test
  artifacts:
    paths:
      - build/jacoco-report/jacoco.xml

coverage:
  stage: coverage
  image: registry.gitlab.com/haynes/jacoco2cobertura:1.0.7
  script:
    - python /opt/cover2cover.py build/jacoco-report/jacoco.xml $CI_PROJECT_DIR/src/main/java/ > build/cobertura.xml
  needs: ["test"]
  artifacts:
    reports:
      cobertura: build/cobertura.xml

pages:
  stage: javadoc
  script:
    - gradle javadoc
    - mv build/docs/javadoc public
  artifacts:
    paths:
      - public
  only:
    - develop

.deploy:
  stage: deploy
  image: ruby
  script:
    - gem install dpl
    - dpl --provider=heroku --app=$HEROKU_APP --api_key=$HEROKU_API_KEY --skip-cleanup=true

deploy-dev:
  extends: .deploy
  before_script:
    - cat $APPLICATION_DEV_PROPERTIES_CI > src/main/resources/application-dev.properties
  variables:
    HEROKU_APP: $HEROKU_APP_DEV
  only:
    - develop

deploy-prod:
  extends: .deploy
  before_script:
    - cat $APPLICATION_PROD_PROPERTIES_CI > src/main/resources/application-prod.properties
  variables:
    HEROKU_APP: $HEROKU_APP_PROD
  when: manual
  only:
    - tags
